
import knižnica.*;

public class IhlyABubliny extends GRobot
{
	private final Zoznam<Ihla> ihly = new Zoznam<>();
	private final Zoznam<Bublina> bubliny = new Zoznam<>();

	private boolean rovnomerne = true;
	private int početIhiel = 7;
	private int pridajNaraz = 5;

	private int viditeľnýchBublín = 100;

	private final Obrázok ikonaOznačeného = new Obrázok(16, 16);

	private PoložkaPonuky položkaPočet;
	private PoložkaPonuky položkaPridaj;
	private PoložkaPonuky položkaRovnomerne;

	private IhlyABubliny()
	{
		for (int i = 0; i < viditeľnýchBublín; ++i)
			bubliny.pridaj(new Bublina());

		for (int i = 0; i < viditeľnýchBublín * 6; ++i)
		{
			Bublina bublina = new Bublina();
			bublina.skry();
			bubliny.pridaj(bublina);
		}

		for (int i = 0; i < viditeľnýchBublín * 49; ++i)
			ihly.pridaj(new Ihla());

		kresliDoObrázka(ikonaOznačeného);
		kruh(4);

		položkaPočet = Svet.pridajPoložkuPonuky(
			"Počet ihiel", Kláves.VK_H, Kláves.VK_N);
		položkaPridaj = Svet.pridajPoložkuPonuky(
			"Prírastok bublín", Kláves.VK_B, Kláves.VK_B);
		položkaRovnomerne = Svet.pridajPoložkuPonuky(
			"Rovnomerné rozloženie", Kláves.VK_R, Kláves.VK_M);
		položkaRovnomerne.ikona(ikonaOznačeného);

		farba(šedá);
		písmo("Cambria", 44);
		zrýchlenie(0.1, false);
		gyroskop(90.0);
		zdvihniPero();
		náhodnáPoloha();
		náhodnýCieľ();
		aktivuj();
	}

	@Override public void voľbaPoložkyPonuky()
	{
		if (položkaPočet.aktivovaná())
		{
			Long počet = Svet.upravCeléČíslo(početIhiel, "Počet ihiel");
			if (null != počet)
			{
				if (počet <= 0) početIhiel = 1;
				else if (počet > 14) početIhiel = 14;
				else početIhiel = počet.intValue();
			}
		}
		else if (položkaPridaj.aktivovaná())
		{
			Long počet = Svet.upravCeléČíslo(pridajNaraz, "Prírastok bublín");
			if (null != počet)
			{
				if (počet <= 0) pridajNaraz = 1;
				else if (počet > 100) pridajNaraz = 100;
				else pridajNaraz = počet.intValue();
			}
		}
		else if (položkaRovnomerne.aktivovaná())
		{
			rovnomerne = !rovnomerne;
			if (rovnomerne)
				položkaRovnomerne.ikona(ikonaOznačeného);
			else
				položkaRovnomerne.ikona((Obrázok)null);
			Svet.pípni();
		}
	}

	public void náhodnýCieľ()
	{
		cieľ(
			Svet.náhodnéCeléČíslo(
				(long)Svet.najmenšieX(),
				(long)Svet.najväčšieX()),
			Svet.náhodnéCeléČíslo(
				(long)Svet.najmenšieY(),
				(long)Svet.najväčšieY()));
	}

	private void pridajBubliny()
	{
		ďalší: for (int i = 0; i < pridajNaraz; ++i)
		{
			for (Bublina bublina : bubliny)
				if (bublina.skrytý())
				{
					bublina.farba(akvamarínová);
					bublina.náhodnáPoloha();
					bublina.zobraz();
					continue ďalší;
				}

			bubliny.pridaj(new Bublina());
		}
	}

	private void aktivujIhlu(Poloha p, Smer s)
	{
		for (Ihla ihla : ihly)
			if (ihla.neaktívny())
			{
				ihla.poloha(p);
				ihla.smer(s);
				ihla.aktivuj();
				return;
			}

		Ihla ihla = new Ihla();
		ihly.pridaj(ihla);
		ihla.poloha(p);
		ihla.smer(s);
		ihla.aktivuj();
	}

	private void aktivujIhly(Poloha p)
	{
		double pôvodnýUhol = 360.0 / početIhiel;
		double pootočenie = Svet.náhodnéReálneČíslo(pôvodnýUhol);
		if (rovnomerne)
		{
			for (int i = 0; i < početIhiel; ++i)
				aktivujIhlu(p, new Uhol(pôvodnýUhol * i + pootočenie));
		}
		else
		{
			for (int j = 0; j < početIhiel; ++j)
			{
				int i = (int)Svet.náhodnéCeléČíslo(početIhiel);
				aktivujIhlu(p, new Uhol(pôvodnýUhol * i + pootočenie));
			}
		}
	}

	@Override public void kresliTvar()
	{
		text(Svet.celéNaRímske(viditeľnýchBublín));
	}

	@Override public void zastavenie()
	{
		náhodnýCieľ();
	}

	@Override public void tik()
	{
		viditeľnýchBublín = 0;
		for (Bublina bublina : bubliny)
		{
			if (bublina.viditeľný())
			{
				++viditeľnýchBublín;
				for (Ihla ihla : ihly)
					if (ihla.aktívny() && ihla.koliduje(bublina))
					{
						ihla.deaktivuj();
						if (akvamarínová == bublina.farba())
						{
							bublina.farba(žltá);
						}
						else if (žltá == bublina.farba())
						{
							bublina.náhodnáFarba();
						}
						else if (červená == bublina.farba())
						{
							--viditeľnýchBublín;
							bublina.skry();
							aktivujIhly(bublina);
						}
						else
						{
							bublina.farba(červená);
						}
						break;
					}
			}

			if (bublina.viditeľný() && bublina.neaktívny())
			{
				for (Bublina bublina2 : bubliny)
				{
					if (bublina != bublina2 && bublina2.viditeľný() &&
						bublina2.neaktívny() && bublina2.koliduje(bublina))
					{
						Svet.nekresli();
						Poloha p; double posun;
						bublina2.otočNa(bublina);
						bublina2.vpravo(180);
						posun = 4 + bublina.veľkosť() / 2;
						bublina2.skoč(posun);
						p = bublina2.poloha();
						bublina2.odskoč(posun);
						bublina2.cieľ(p);
						bublina.otočNa(bublina2);
						bublina.vpravo(180);
						posun = 4 + bublina2.veľkosť() / 2;
						bublina.skoč(posun);
						p = bublina.poloha();
						bublina.odskoč(posun);
						bublina.cieľ(p);
						Svet.kresli();
						break;
					}
				}
			}
		}
	}

	@Override public void klik()
	{
		if (ÚdajeUdalostí.tlačidloMyši(PRAVÉ)) pridajBubliny();
		else aktivujIhly(ÚdajeUdalostí.polohaMyši());
	}

	public static void main(String[] args)
	{
		Svet.skry();
		Svet.nekresli();
		Svet.použiKonfiguráciu("IhlyABubliny.cfg");
		new IhlyABubliny();
		Svet.zbaľ();
		Svet.kresli();
		Svet.zobraz();
	}
}
