
import knižnica.*;
import java.awt.Shape;

public class Detonácia extends GRobot
{
	private final static Oblasť tvarDetonácie;

	static
	{
		Oblasť oblasť = null;

		try
		{
			svgPodpora.vymaž();
			svgPodpora.čítaj("detonacia.svg");
			Shape tvar = svgPodpora.dajVýsledný(0);
			oblasť = new Oblasť(SVGPodpora.presuňDoStredu(tvar));
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

		tvarDetonácie = oblasť;
	}

	final static KreslenieTvaru kreslenieDetonácie =
		r -> r.vyplňOblasť(tvarDetonácie);

	private boolean nadHladinou = false;

	public Detonácia()
	{
		skry();
		veľkosť(15);
		mierka(1);
		vlastnýTvar(kreslenieDetonácie);
		zdvihniPero();
		farba(snehová);
		cieľováFarba(svetlošedá);
		použiKruhovýNáter();
	}

	@Override public void aktivita()
	{
		vpred(1);
		veľkosť(veľkosť() + 2.5);
		if (veľkosť() > 40) deaktivuj();
	}

	@Override public void aktivácia()
	{
		veľkosť(5);
		zobraz();
	}

	@Override public void deaktivácia()
	{
		skry();
	}
}
