
import knižnica.*;
import java.awt.Shape;

public class Ponorka extends GRobot
{
	private final static Oblasť smerVpravo;
	private final static Oblasť smerVľavo;

	static
	{
		Oblasť oblasť = null;

		try
		{
			svgPodpora.vymaž();
			svgPodpora.čítaj("ponorka.svg");
			Shape tvar = svgPodpora.dajVýsledný(0);
			oblasť = new Oblasť(SVGPodpora.presuňDoStredu(tvar));
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

		smerVpravo = oblasť;
		oblasť = null;

		{
			svgPodpora.pridajTransformácie(0, "scaleX(-1)");
			Shape tvar = svgPodpora.dajVýsledný(0);
			oblasť = new Oblasť(SVGPodpora.presuňDoStredu(tvar));
		}

		smerVľavo = oblasť;
	}

	private final static KreslenieTvaru kresleniePonorky =
		r -> ((Ponorka)r).kresliPonorku();

	private void kresliPonorku()
	{
		if (rýchlosťPosunu() >= 0)
			vyplňOblasť(smerVpravo);
		else
			vyplňOblasť(smerVľavo);

		if (energia < 16) farba(svetločervená);
		else if (energia < 32) farba(tmavožltá);
		else farba(svetlozelená);

		skoč(energia - 65, 17);
		vyplňObdĺžnik(energia, 2);
		skoč(65 - energia, 0);

		farba(čierna);
		kresliObdĺžnik(65, 2);
	}


	private int energia = 65;
	private int intervalOpravy = 0;

	public Ponorka()
	{
		skry();

		ohranič(Svet.najväčšieX() + 65, Svet.najväčšieY());
		vlastnýTvar(kresleniePonorky);
		zdvihniPero();

		farba(tmavošedá.tmavšia(0.5));
	}

	public boolean poškoď(int úroveň)
	{
		if (úroveň >= energia)
		{
			deaktivuj();
			return true;
		}

		energia -= úroveň;
		intervalOpravy = 200;
		return false;
	}

	@Override public void aktivita()
	{
		if (energia < 65)
		{
			if (intervalOpravy > 0) --intervalOpravy; else
			{
				intervalOpravy = 50;
				++energia;
			}
		}
	}

	@Override public void aktivácia()
	{
		energia = 65;
		intervalOpravy = 0;

		náhodnáPoloha();
		if (polohaY() > 200) polohaY(200);

		rýchlosťPosunu(Svet.náhodnéReálneČíslo(0.75, 1.25), false);
		if (0 == Svet.náhodnéCeléČíslo(0, 1))
			rýchlosťPosunu(-rýchlosťPosunu(), false);

		zobraz();
	}

	@Override public void deaktivácia()
	{
		skry();
	}
}
