
import knižnica.*;
import java.awt.Shape;

public class Sud extends GRobot
{
	private final static Oblasť tvarSudu;

	static
	{
		Oblasť oblasť = null;

		try
		{
			svgPodpora.vymaž();
			svgPodpora.čítaj("sud.svg");
			Shape tvar = svgPodpora.dajVýsledný(0);
			oblasť = new Oblasť(SVGPodpora.presuňDoStredu(tvar));
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

		tvarSudu = oblasť;
	}

	final static KreslenieTvaru kreslenieSudu =
		r -> r.vyplňOblasť(tvarSudu);

	private boolean nadHladinou = false;
	private final Vyšplechnutie vyšplechnutie = new Vyšplechnutie();

	public Sud()
	{
		skry();

		ohranič(Svet.najväčšieX() + 65, Svet.najväčšieY() + 10);
		vlastnýTvar(kreslenieSudu);
		zdvihniPero();

		farba(tmavošedá.tmavšia(0.5));
	}

	public void aktivujVpravo()
	{
		nadHladinou = true;
		otáčajTvar(-3.0, false);
		rýchlosťPosunu(3, false);
		zrýchleniePosunu(-0.05, false);
		aktivuj();
	}

	public void aktivujVľavo()
	{
		nadHladinou = true;
		otáčajTvar(3.0, false);
		rýchlosťPosunu(-3, false);
		zrýchleniePosunu(0.05, false);
		aktivuj();
	}

	@Override public void aktivita()
	{
		if (rýchlosťPosunu() >= -0.5 && rýchlosťPosunu() <= 0.5)
		{
			zrýchleniePosunu(0, false);
			rýchlosťPosunu(0, false);
		}

		if (nadHladinou && polohaY() < 240)
		{
			vyšplechnutie.skočNa(this);
			vyšplechnutie.aktivuj(15);
			nadHladinou = false;

			if (otáčanieTvaru() > 180)
				otáčajTvar(-0.5, false);
			else if (otáčanieTvaru() < 180)
				otáčajTvar(0.5, false);
			zrýchlenie(0, false);
			rýchlosť(-2, false);
		}
	}

	@Override public void aktivácia()
	{
		polohaY(250);
		pootočenieTvaru(0);
		rýchlosť(3, false);
		zrýchlenie(-0.2, false);
		zobraz();
	}

	@Override public void deaktivácia()
	{
		skry();
	}

	@Override public boolean mimoHraníc(Bod[] poleBodov, double uhol)
	{
		domov();
		deaktivuj();
		return false;
	}
}
