
import knižnica.*;
import java.awt.Shape;

public class Torpédo extends GRobot
{
	private final static Oblasť tvarTorpéda;

	static
	{
		Oblasť oblasť = null;

		try
		{
			svgPodpora.vymaž();
			svgPodpora.čítaj("torpedo.svg");
			Shape tvar = svgPodpora.dajVýsledný(0);
			oblasť = new Oblasť(SVGPodpora.presuňDoStredu(tvar));
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

		tvarTorpéda = oblasť;
	}

	final static KreslenieTvaru kreslenieTorpéda =
		r -> ((Torpédo)r).kresliTorpédo();

	private void kresliTorpédo()
	{
		vyplňOblasť(tvarTorpéda);
		farba(snehová); kruh(2);
	}

	private final Detonácia detonácia = new Detonácia();

	public Torpédo()
	{
		skry();

		odskoč(25);
		ohranič(Svet.najväčšieX() + 65, Svet.najväčšieY() - 25);
		vlastnýTvar(kreslenieTorpéda);
		zdvihniPero();
		maximálnaRýchlosť(5);

		farba(tmavošedá.tmavšia(0.5));
	}

	@Override public void aktivácia()
	{
		rýchlosť(0, false);
		zrýchlenie(0.1, false);
		zobraz();
	}

	@Override public void deaktivácia()
	{
		skry();
	}

	@Override public boolean mimoHraníc(Bod[] poleBodov, double uhol)
	{
		deaktivuj();
		detonácia.skočNa(this);
		detonácia.polohaY(240);
		detonácia.aktivuj();
		return false;
	}
}
