
import knižnica.*;
import java.awt.Shape;

public class Výbuch extends GRobot
{
	private final static Oblasť tvarVýbuchu;

	static
	{
		Oblasť oblasť = null;

		try
		{
			svgPodpora.vymaž();
			svgPodpora.čítaj("vybuch.svg");
			Shape tvar = svgPodpora.dajVýsledný(0);
			oblasť = new Oblasť(SVGPodpora.presuňDoStredu(tvar));
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

		tvarVýbuchu = oblasť;
	}

	final static KreslenieTvaru kreslenieVýbuchu =
		r -> r.vyplňOblasť(tvarVýbuchu);

	private boolean nadHladinou = false;

	public Výbuch()
	{
		skry();
		veľkosť(15);
		mierka(1);
		vlastnýTvar(kreslenieVýbuchu);
		zdvihniPero();
		farba(svetložltá);
		cieľováFarba(svetločervená);
		použiKruhovýNáter();
	}

	@Override public void aktivita()
	{
		veľkosť(veľkosť() + 2.5);
		náhodnýSmer();
	}

	@Override public void aktivácia()
	{
		Svet.generátorTónov().setWaveType(13);

		for (int i = 15; i >= 0; --i)
		{
			Svet.hrajTón(
				i * 5,
				i * 0.05,
				0.01);
		}

		veľkosť(10);
		zobraz();
	}

	@Override public void deaktivácia()
	{
		skry();
	}
}
