
import knižnica.*;

public class Platforma extends GRobot
{
	private int šírka, výška, polVýšky;

	public Platforma(int šírka)
	{
		this(šírka, 10, tmavozelená);
	}

	public Platforma(int šírka, int výška)
	{
		this(šírka, výška, zelená);
	}

	public Platforma(int šírka, int výška, Farba farba)
	{
		hrúbkaČiary(1);
		farba(farba);
		rozmer(šírka, výška);
	}

	public void rozmer(int šírka)
	{
		rozmer(šírka, 10);
	}

	public void rozmer(int šírka, int výška)
	{
		this.šírka = šírka;
		this.výška = výška;
		polVýšky = výška / 2;
	}

	@Override public void kresliTvar()
	{
		vyplňObdĺžnik(šírka, výška);
		farba(čierna);
		kresliObdĺžnik(šírka, výška);
	}

	public double úroveňZeme()
	{
		return polohaY() + výška;
	}

	public boolean koliduje(Zberateľ zberateľ)
	{
		if (zberateľ.rýchlosť() >= 0) return false;
		Bod noha1 = zberateľ.noha1();
		Bod noha2 = zberateľ.noha2();
		if (bodVObdĺžniku(noha1, šírka, výška) ||
			bodVObdĺžniku(noha2, šírka, výška)) return true;
		if (zberateľ.rýchlosť() <= -polVýšky)
		{
			noha1.polohaY(noha1.polohaY() - polVýšky);
			noha2.polohaY(noha2.polohaY() - polVýšky);
			if (bodVObdĺžniku(noha1, šírka, výška) ||
				bodVObdĺžniku(noha2, šírka, výška)) return true;
		}
		return false;
	}
}
