
import knižnica.*;

public class ZberateľMincí extends GRobot
{
	private final static Zoznam<Platforma> platformy = new Zoznam<>();
	private final static Zoznam<Minca> mince = new Zoznam<>();
	private final static Zoznam<MetačBleskov> metače = new Zoznam<>();

	private static Zberateľ zberateľ;

	private final static Zoznam<Integer> hodnoty = new Zoznam<>(
		5, 10, 20, 50, 100);

	private ZberateľMincí()
	{
		skry();
		kresliNaStrop();
		písmo("Cambria", 48);
		Svet.farbaPozadia(nebeská);

		for (int i = 0; i < 10; ++i)
		{
			Platforma platforma = new Platforma(
				(int)Svet.náhodnéCeléČíslo(30, 100));
			platforma.náhodnáPoloha();
			platformy.pridaj(platforma);
		}

		for (int i = 0; i < 10; ++i)
		{
			Platforma platforma = new Platforma(
				(int)Svet.náhodnéCeléČíslo(30, 100));
			platforma.náhodnáPoloha();
			platforma.preskočVľavo(Svet.šírka());
			platformy.pridaj(platforma);
		}

		for (int i = 0; i < 10; ++i)
		{
			Platforma platforma = new Platforma(
				(int)Svet.náhodnéCeléČíslo(30, 100));
			platforma.náhodnáPoloha();
			platforma.preskočVpravo(Svet.šírka());
			platformy.pridaj(platforma);
		}

		for (int i = 0; i < 20; ++i)
		{
			Minca minca = new Minca(hodnoty.náhodnýPrvok());
			minca.náhodnáPoloha();
			mince.pridaj(minca);
		}

		for (int i = 0; i < 20; ++i)
		{
			Minca minca = new Minca(hodnoty.náhodnýPrvok());
			minca.náhodnáPoloha();
			minca.preskočVľavo(Svet.šírka());
			mince.pridaj(minca);
		}

		for (int i = 0; i < 20; ++i)
		{
			Minca minca = new Minca(hodnoty.náhodnýPrvok());
			minca.náhodnáPoloha();
			minca.preskočVpravo(Svet.šírka());
			mince.pridaj(minca);
		}

		{
			MetačBleskov metač = new MetačBleskov();
			metač.náhodnáPoloha();
			metač.nastavPosun(0);
			metače.pridaj(metač);

			metač = new MetačBleskov();
			metač.náhodnáPoloha();
			metač.nastavPosun(-Svet.šírka());
			metače.pridaj(metač);

			metač = new MetačBleskov();
			metač.náhodnáPoloha();
			metač.nastavPosun(Svet.šírka());
			metače.pridaj(metač);
		}

		Svet.pridajPoložkuPonuky("Nová hra", Kláves.VK_N, Kláves.VK_N);
		zberateľ.aktivuj();
	}

	private void nováHra()
	{
		strop.vymažGrafiku();
		int i = 0;
		for (Platforma platforma : platformy)
		{
			platforma.rozmer((int)Svet.náhodnéCeléČíslo(30, 100));
			if (i < 10)
			{
				platforma.náhodnáPoloha();
			}
			else if (i < 20)
			{
				platforma.náhodnáPoloha();
				platforma.preskočVľavo(Svet.šírka());
			}
			else
			{
				platforma.náhodnáPoloha();
				platforma.preskočVpravo(Svet.šírka());
			}
			++i;
		}

		i = 0;
		for (Minca minca : mince)
		{
			minca.hodnota(hodnoty.náhodnýPrvok());
			if (i < 20)
			{
				minca.náhodnáPoloha();
			}
			else if (i < 40)
			{
				minca.náhodnáPoloha();
				minca.preskočVľavo(Svet.šírka());
			}
			else
			{
				minca.náhodnáPoloha();
				minca.preskočVpravo(Svet.šírka());
			}
			minca.zobraz();
			++i;
		}

		{
			MetačBleskov metač = metače.daj(0);
			metač.náhodnáPoloha();
			metač.nastavPosun(0);
			metač.dosiahnutieCieľa();
			metač.zobraz();

			metač = metače.daj(1);
			metač.náhodnáPoloha();
			metač.nastavPosun(-Svet.šírka());
			metač.dosiahnutieCieľa();
			metač.zobraz();

			metač = metače.daj(2);
			metač.náhodnáPoloha();
			metač.nastavPosun(Svet.šírka());
			metač.dosiahnutieCieľa();
			metač.zobraz();
		}

		zberateľ.reset();
	}

	public static void posuňProstredie(int posun)
	{
		for (Platforma platforma : platformy)
			platforma.preskočVpravo(posun);
		for (Minca minca : mince)
			minca.preskočVpravo(posun);
		for (MetačBleskov metač : metače)
			metač.posuňMetač(posun);
		zberateľ.preskočVpravo(posun);
	}

	@Override public void voľbaPoložkyPonuky()
	{
		if (ÁNO == Svet.otázka("Želáte si začať novú hru?")) nováHra();
	}

	@Override public void tik()
	{
		if (zberateľ.viditeľný())
		{
			for (Platforma platforma : platformy)
				if (platforma.koliduje(zberateľ))
				{
					zberateľ.dopadni();
					zberateľ.skočNa(platforma);
					break;
				}

			boolean vyzbierané = true;
			for (Minca minca : mince)
				if (minca.viditeľný())
				{
					vyzbierané = false;
					if (minca.koliduje(zberateľ))
					{
						// Bonus
						minca.skry();
					}
				}

			if (vyzbierané)
			{
				farba(zelená);
				text("Hotovo!");
				zberateľ.deaktivuj();
				for (MetačBleskov metač : metače)
					metač.skry();
			}
			else
			{
				for (MetačBleskov metač : metače)
					if (metač.viditeľný() && metač.koliduje(zberateľ))
					{
						if (metač.elektrizuje())
						{
							if (zberateľ.zraň())
							{
								farba(červená);
								text("Koniec hry");
							}
						}
						else metač.elektrizuj();
					}
			}
		}

		if (Svet.neboloPrekreslené())
			Svet.prekresli();
	}


	public static void main(String[] args)
	{
		Svet.nekresli();
		Svet.použiKonfiguráciu("ZberateľMincí.cfg");
		zberateľ = new Zberateľ();
		new ZberateľMincí();
		Svet.zbaľ();
	}
}
